package com.agiledeveloper;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class GameOfLifeUI extends JFrame {
  final int SIZE = 20;
  final int WINDOW_WIDTH = 700;
  final int DELAY = 5000;
  GameOfLife _gameOfLife = new GameOfLife();

  JButton[][] _buttons;
  boolean[][] _life = new boolean[SIZE][SIZE];
  
  @Override
  protected void frameInit() {
    super.frameInit();
    setSize(WINDOW_WIDTH, WINDOW_WIDTH);
    getContentPane().setLayout(new GridLayout(SIZE, SIZE));
    _buttons = new JButton[SIZE][SIZE];
    for (int i = 0; i < SIZE; i++) {
      for (int j = 0; j < SIZE; j++) {
        final int row = i;
        final int column = j;
        JButton button = new JButton();
        button.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent actionEvent) {
            JButton button = (JButton) actionEvent.getSource();
            _life[row][column] = !_life[row][column];
            button.setText("");
            if(_life[row][column]) button.setText("X");
          }
        });
        _buttons[i][j] = button;
        getContentPane().add(button);
      }
    }
    
    new Timer(DELAY, new ActionListener() {
      public void actionPerformed(ActionEvent actionEvent) {
        
        _life = _gameOfLife.nextGeneration(_life);
        
        for (int i = 0; i < SIZE; i++) {
          for (int j = 0; j < SIZE; j++) {
            _buttons[i][j].setText("");
            if(_life[i][j]) _buttons[i][j].setText("X");
          }
        }
      }
    }).start();
  }
  
  public static void main(String[] args) {
    JFrame frame = new GameOfLifeUI();
    frame.setVisible(true);
  }
}